# generated by cabal-rpm-2.1.2
# https://docs.fedoraproject.org/en-US/packaging-guidelines/Haskell/

%global pkg_name idris
%global pkgver %{pkg_name}-%{version}

%ifarch armv7hl
%undefine with_ghc_prof
%endif

# testsuite missing deps: tasty-golden

Name:           %{pkg_name}
Version:        1.3.4
Release:        %autorelease
Summary:        Functional Programming Language with Dependent Types

License:        BSD-3-Clause
Url:            https://hackage.haskell.org/package/%{name}
# Begin cabal-rpm sources:
Source0:        https://hackage.haskell.org/package/%{pkgver}/%{pkgver}.tar.gz
# End cabal-rpm sources

# Begin cabal-rpm deps:
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-aeson-devel
BuildRequires:  ghc-annotated-wl-pprint-devel
BuildRequires:  ghc-ansi-terminal-devel
BuildRequires:  ghc-ansi-wl-pprint-devel
BuildRequires:  ghc-array-devel
BuildRequires:  ghc-async-devel
BuildRequires:  ghc-base-devel
BuildRequires:  ghc-base64-bytestring-devel
BuildRequires:  ghc-binary-devel
BuildRequires:  ghc-blaze-html-devel
BuildRequires:  ghc-blaze-markup-devel
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-cheapskate-devel
BuildRequires:  ghc-code-page-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-deepseq-devel
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-filepath-devel
BuildRequires:  ghc-fingertree-devel
BuildRequires:  ghc-fsnotify-devel
BuildRequires:  ghc-haskeline-devel
BuildRequires:  ghc-ieee754-devel
BuildRequires:  ghc-libffi-devel
BuildRequires:  ghc-megaparsec-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-network-devel
BuildRequires:  ghc-optparse-applicative-devel
BuildRequires:  ghc-parser-combinators-devel
BuildRequires:  ghc-pretty-devel
BuildRequires:  ghc-process-devel
BuildRequires:  ghc-regex-tdfa-devel
BuildRequires:  ghc-safe-devel
BuildRequires:  ghc-split-devel
BuildRequires:  ghc-terminal-size-devel
BuildRequires:  ghc-text-devel
BuildRequires:  ghc-time-devel
BuildRequires:  ghc-transformers-devel
BuildRequires:  ghc-uniplate-devel
BuildRequires:  ghc-unix-devel
BuildRequires:  ghc-unordered-containers-devel
BuildRequires:  ghc-utf8-string-devel
BuildRequires:  ghc-vector-devel
BuildRequires:  ghc-vector-binary-instances-devel
BuildRequires:  ghc-zip-archive-devel
%if %{with ghc_prof}
BuildRequires:  ghc-aeson-prof
BuildRequires:  ghc-annotated-wl-pprint-prof
BuildRequires:  ghc-ansi-terminal-prof
BuildRequires:  ghc-ansi-wl-pprint-prof
BuildRequires:  ghc-array-prof
BuildRequires:  ghc-async-prof
BuildRequires:  ghc-base-prof
BuildRequires:  ghc-base64-bytestring-prof
BuildRequires:  ghc-binary-prof
BuildRequires:  ghc-blaze-html-prof
BuildRequires:  ghc-blaze-markup-prof
BuildRequires:  ghc-bytestring-prof
BuildRequires:  ghc-cheapskate-prof
BuildRequires:  ghc-code-page-prof
BuildRequires:  ghc-containers-prof
BuildRequires:  ghc-deepseq-prof
BuildRequires:  ghc-directory-prof
BuildRequires:  ghc-filepath-prof
BuildRequires:  ghc-fingertree-prof
BuildRequires:  ghc-fsnotify-prof
BuildRequires:  ghc-haskeline-prof
BuildRequires:  ghc-ieee754-prof
BuildRequires:  ghc-libffi-prof
BuildRequires:  ghc-megaparsec-prof
BuildRequires:  ghc-mtl-prof
BuildRequires:  ghc-network-prof
BuildRequires:  ghc-optparse-applicative-prof
BuildRequires:  ghc-parser-combinators-prof
BuildRequires:  ghc-pretty-prof
BuildRequires:  ghc-process-prof
BuildRequires:  ghc-regex-tdfa-prof
BuildRequires:  ghc-safe-prof
BuildRequires:  ghc-split-prof
BuildRequires:  ghc-terminal-size-prof
BuildRequires:  ghc-text-prof
BuildRequires:  ghc-time-prof
BuildRequires:  ghc-transformers-prof
BuildRequires:  ghc-uniplate-prof
BuildRequires:  ghc-unix-prof
BuildRequires:  ghc-unordered-containers-prof
BuildRequires:  ghc-utf8-string-prof
BuildRequires:  ghc-vector-prof
BuildRequires:  ghc-vector-binary-instances-prof
BuildRequires:  ghc-zip-archive-prof
%endif
BuildRequires:  gmp-devel
Requires:       %{name}-common = %{version}-%{release}
# End cabal-rpm deps
BuildRequires:  gc-devel
# needs sphinx-build
BuildRequires:  python3-sphinx
## idris compiles to C and then uses gcc linking to the static rts library
## to generate executables (so devel files are included in the main package)
Requires:       gcc
Requires:       gmp-devel
Requires:       %{name}-static = %{version}-%{release}

%description
Idris is a general purpose language with full dependent types. It is compiled,
with eager evaluation. Dependent types allow types to be predicated on values,
meaning that some aspects of a program's behaviour can be specified precisely
in the type. The language is closely related to Epigram and Agda.
There is a tutorial at <https://www.idris-lang.org/documentation>.
Features include:

* Full, first class, dependent types with dependent pattern matching
* where clauses, with rule, case expressions, pattern matching let and
  lambda bindings
* Interfaces (similar to type classes), monad comprehensions
* do notation, idiom brackets, syntactic conveniences for lists, tuples,
  dependent pairs
* Totality checking
* Coinductive types
* Indentation significant syntax, extensible syntax
* Cumulative universes
* Simple foreign function interface (to C)
* Hugs style interactive environment.


%package common
Summary:        Idris libraries
BuildArch:      noarch

%description common
This package provides the Idris libraries development files.


%package static
Summary:        Idris RTS

%description static
This package provides the Idris RTS.


%package -n ghc-%{name}
Summary:        Haskell %{name} library
Requires:       %{name}-common = %{version}-%{release}
Requires:       %{name}-static = %{version}-%{release}

%description -n ghc-%{name}
This package provides the Haskell %{name} shared library.


%package -n ghc-%{name}-devel
Summary:        Haskell %{name} library development files
Provides:       ghc-%{name}-static = %{version}-%{release}
Provides:       ghc-%{name}-static%{?_isa} = %{version}-%{release}
%if %{defined ghc_version}
Requires:       ghc-compiler = %{ghc_version}
%endif
Requires:       ghc-%{name}%{?_isa} = %{version}-%{release}
# Begin cabal-rpm deps:
Requires:       gmp-devel%{?_isa}
# End cabal-rpm deps

%description -n ghc-%{name}-devel
This package provides the Haskell %{name} library development files.


%package docs
Summary:        Idris library docs
BuildArch:      noarch

%description docs
This package provides the library docs for the Idris programming language.


%package manual
Summary:        The Idris manual
BuildArch:      noarch

%description manual
This package provides the manual for the Idris programming language.


%if %{with haddock}
%package -n ghc-%{name}-doc
Summary:        Haskell %{name} library documentation
BuildArch:      noarch
Requires:       ghc-filesystem

%description -n ghc-%{name}-doc
This package provides the Haskell %{name} library documentation.
%endif


%if %{with ghc_prof}
%package -n ghc-%{name}-prof
Summary:        Haskell %{name} profiling library
Requires:       ghc-%{name}-devel%{?_isa} = %{version}-%{release}
Supplements:    (ghc-%{name}-devel and ghc-prof)

%description -n ghc-%{name}-prof
This package provides the Haskell %{name} profiling library.
%endif


%prep
# Begin cabal-rpm setup:
%setup -q
# End cabal-rpm setup
cabal-tweak-dep-ver aeson '< 1.6' '< 2.2'
cabal-tweak-dep-ver bytestring '< 0.11' '< 0.12'
cabal-tweak-dep-ver fsnotify '< 0.4' '< 0.5'
cabal-tweak-dep-ver libffi '< 0.2' '< 0.3'
cabal-tweak-dep-ver network '< 3.1.2' '< 3.2'
cabal-tweak-dep-ver optparse-applicative '< 0.17' '< 0.18'
cabal-tweak-dep-ver text '< 1.4' '< 2.2'
cabal-tweak-dep-ver vector '< 0.13' '< 0.14'
cabal-tweak-flag FFI True
cabal-tweak-flag GMP True


%build
export LD_LIBRARY_PATH=$PWD/dist/build
# Begin cabal-rpm build:
%ghc_lib_build
# End cabal-rpm build


%install
export LD_LIBRARY_PATH=$PWD/dist/build
# Begin cabal-rpm install
%ghc_lib_install
mv %{buildroot}%{_ghcdocdir}{,-common}
mkdir -p %{buildroot}%{_datadir}/bash-completion/completions/
%{buildroot}%{_bindir}/%{name} --bash-completion-script %{name} | sed s/filenames/default/ > %{buildroot}%{_datadir}/bash-completion/completions/%{name}
%{buildroot}%{_bindir}/idris-codegen-c --bash-completion-script idris-codegen-c | sed s/filenames/default/ > %{buildroot}%{_datadir}/bash-completion/completions/idris-codegen-c
%{buildroot}%{_bindir}/idris-codegen-javascript --bash-completion-script idris-codegen-javascript | sed s/filenames/default/ > %{buildroot}%{_datadir}/bash-completion/completions/idris-codegen-javascript
%{buildroot}%{_bindir}/idris-codegen-node --bash-completion-script idris-codegen-node | sed s/filenames/default/ > %{buildroot}%{_datadir}/bash-completion/completions/idris-codegen-node
# End cabal-rpm install

# https://github.com/idris-lang/Idris-dev/issues/4495
mv %{buildroot}%{_datadir}/%{pkgver}/rts/libidris_rts.a %{buildroot}%{_libdir}

# https://github.com/idris-lang/Idris-dev/issues/4497
chmod +r -R %{buildroot}%{_datadir}/%{pkgver}/docs

mkdir -p %{buildroot}%{_docdir}/idris-manual
cp -p idris-tutorial.pdf %{buildroot}%{_docdir}/idris-manual/


%files
# Begin cabal-rpm files:
%{_bindir}/%{name}
%{_bindir}/idris-codegen-c
%{_bindir}/idris-codegen-javascript
%{_bindir}/idris-codegen-node
%{_datadir}/bash-completion/completions/%{name}
%{_datadir}/bash-completion/completions/idris-codegen-c
%{_datadir}/bash-completion/completions/idris-codegen-javascript
%{_datadir}/bash-completion/completions/idris-codegen-node
# End cabal-rpm files
%{_mandir}/man1/idris.1*


%files common
# Begin cabal-rpm files:
%license LICENSE
%doc CHANGELOG.md CONTRIBUTING.md CONTRIBUTORS README.md
%{_datadir}/%{pkgver}
# End cabal-rpm files
%exclude %{_datadir}/%{pkgver}/docs


%files docs
%dir %{_datadir}/%{pkgver}
%{_datadir}/%{pkgver}/docs


%files manual
%{_docdir}/idris-manual


%files static
%attr(644, -, -) %{_libdir}/libidris_rts.a


%files -n ghc-%{name} -f ghc-%{name}.files


%files -n ghc-%{name}-devel -f ghc-%{name}-devel.files


%if %{with haddock}
%files -n ghc-%{name}-doc -f ghc-%{name}-doc.files
%license LICENSE
%endif


%if %{with ghc_prof}
%files -n ghc-%{name}-prof -f ghc-%{name}-prof.files
%endif


%changelog
%autochangelog
